/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "button.h"
#include <Xm/PushB.h>

#define DEFAULT_WIDTH 80
#define DEFAULT_HEIGHT 30

CButton::~CButton()
{

}

CButton::CButton(int nId)
	: CGuiElement(0L, nId)
{
    //m_nId = nId;
}

CButton::CButton(Widget wdgParent, int nId)
	: CGuiElement(wdgParent, 0L, nId)
{
    //m_nId = nId;
}

void CButton::InternalCreate(unsigned long lStyle)
{
    Arg args[20];
    Cardinal argcount = 0;
	
    //XtSetArg(args[argcount],XmNuserData,this); argcount++;
    XtSetArg(args[argcount],XmNwidth,DEFAULT_WIDTH); argcount++;
    XtSetArg(args[argcount],XmNheight,DEFAULT_HEIGHT); argcount++;
    XtSetArg(args[argcount],XmNrecomputeSize,FALSE); argcount++;
	
    m_wdgButton = XmCreatePushButton(Parent(),"Button",args,argcount); 
    XtManageChild(m_wdgButton);

    XtAddCallback(m_wdgButton,XmNactivateCallback,(XtCallbackProc)OnActivate,this);
}

Widget CButton::Container() const
{
    return m_wdgButton;
}

void CButton::OnActivate(Widget w, XtPointer client_data, XmAnyCallbackStruct *call_data)
{
    CButton *pButton = (CButton *)client_data;
	
    pButton->OnPushed(pButton->Id());
}

void CButton::SetCaption(const char *cData)
{
    Arg args[5];
    Cardinal n;
  
    n = 0;
  
    XmString string;
    char *strBuffer = new char[strlen(cData)+1];
    strcpy(strBuffer,cData);
  
    string = XmStringCreate(strBuffer,XmFONTLIST_DEFAULT_TAG);
    delete strBuffer;
	
    XtSetArg(args[n],XmNlabelString, string); n++;
    XtSetValues(m_wdgButton,args,n);

    XmStringFree(string);
}

void CButton::OnPushed(int nId)
{
    SendMessage(EVENT_MASK_BUTTON_PUSHED);
}






