/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#ifndef BUTTON_H

#define BUTTON_H

#include "guielement.h"

class CButton : public CGuiElement
{
 private:
    //int m_nId;
    Widget m_wdgButton;
 private:
    static void OnActivate(Widget w, XtPointer client_data, XmAnyCallbackStruct *call_data);
 protected:
    virtual void OnPushed(int nId);
    virtual void InternalCreate(unsigned long lStyle);
 public:
    virtual Widget Container() const;
    CButton(Widget wdgParent, int nId = 0);
    CButton(int nId = 0);
    ~CButton();
		
    void SetCaption(const char *cData);
    //inline int Id() { return m_nId; }
};

#endif
