/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "datetextfield.h"
#include <Xm/TextF.h>

CDateTextField::CDateTextField(Widget wdgParent)
    : CTextField(wdgParent)
{

}

void CDateTextField::Create(unsigned long lStyle)
{
    CTextField::Create(lStyle);
}

Widget CDateTextField::Container() const
{
    return CTextField::Container();
}

void CDateTextField::SetValue(const CDate &dtValue)
{
    //m_dtValue = dtValue;

    CDate date = dtValue;

    char *strBuffer = new char[strlen((const char *)(CStrings)date)+1];
    strcpy(strBuffer,(const char *)(CStrings)date);	
	
    XmTextFieldSetString(Container(),strBuffer);
	
    delete strBuffer;
}

CDate CDateTextField::Value() const
{
    CDate date;
    
    char *strBuffer = XmTextFieldGetString(Container());
    date = (const char *)strBuffer;
    XtFree(strBuffer);
    
    return date;
}
