/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "fileselectiondialog.h"
#include <Xm/FileSB.h>
#include <basic/macrodefinitions.h>

/*void CFileSelectionDialog::GetPath()
{
	Arg args[20];
	Cardinal argcount = 0;
	//char strPath[4096];
	XmString *strPath;

	//strPath = XmStringCreate("", XmFONTLIST_DEFAULT_TAG); 
	
	//char *strPath;
		
	XtSetArg(args[argcount], XmNdirSpec, &strPath); argcount++;
	XtGetValues(m_wdgFileBox, args, argcount);
	
	//m_strPath = strPath;
}*/

CStrings CFileSelectionDialog::File()
{
    if (m_strPath != "")
    {
	CStrings strRight = m_strPath.Right(1);
		
	if (strRight == "/")
	{
	    strRight = "";
			
	    return strRight;
	}
	else
	{
	    int nPos = m_strPath.FindReverse('/');
			
	    ASSERT(nPos >= 0);
	    CStrings strLeft = m_strPath.Mid(nPos+1);
			
	    return strLeft;
	}
    }
    else
    {
	CStrings strLeft = "";
		
	return strLeft;
    }
}

CStrings CFileSelectionDialog::Path()
{
    if (m_strPath != "")
    {
	CStrings strRight = m_strPath.Right(1);
		
	if (strRight == "/")
	{
	    return m_strPath;
	}
	else
	{
	    int nPos = m_strPath.FindReverse('/');
			
	    ASSERT(nPos >= 0);
	    CStrings strLeft = m_strPath.Left(nPos+1);
			
	    return strLeft;
	}
    }
    else
    {
	CStrings strLeft = "";
		
	return strLeft;
    }
}

CFileSelectionDialog::CFileSelectionDialog(unsigned long lStyle)
    : CModalDialog(lStyle)
{

}

void CFileSelectionDialog::InternalCreate(unsigned long lStyle)
{
    CModalDialog::InternalCreate(lStyle);
    
    Arg args[20];
    Cardinal argcount = 0;
    
    XtSetArg(args[argcount],XmNleftAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount],XmNrightAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount],XmNtopAttachment, XmATTACH_FORM); argcount++;
    if (Style() & DLG_STYLE_SEPARATOR)
    {
	XtSetArg(args[argcount],XmNbottomAttachment, XmATTACH_WIDGET); argcount++;
	XtSetArg(args[argcount],XmNbottomWidget, Separator()); argcount++;
    }
    else
    {
	XtSetArg(args[argcount],XmNbottomAttachment, XmATTACH_FORM); argcount++;
    }

    XtSetArg(args[argcount],XmNwidth, (Dimension)600); argcount++;
    XtSetArg(args[argcount],XmNheight, (Dimension)600); argcount++;
	
    if (Style()&FILESB_STYLE_DIRBROWSE)
    {
	XtSetArg(args[argcount],XmNfileTypeMask, XmFILE_DIRECTORY); argcount++;
    }
		
    m_wdgFileBox = XmCreateFileSelectionBox(Frame(), "fileselectionbox", args, argcount);
    XtManageChild(m_wdgFileBox);

    XtAddCallback(m_wdgFileBox, XmNokCallback, (XtCallbackProc)OkButtonHandler, (XtPointer) this); 	
    XtAddCallback(m_wdgFileBox, XmNcancelCallback, (XtCallbackProc)CancelButtonHandler, (XtPointer) this); 	
}

void CFileSelectionDialog::OkButtonHandler(Widget w, XtPointer client_data, XmSelectionBoxCallbackStruct *call_data)
{
    CFileSelectionDialog *pDlg = (CFileSelectionDialog *)client_data;

    char *filename;

    if (XmStringGetLtoR(call_data->value, XmSTRING_DEFAULT_CHARSET, &filename))
    {
	pDlg->m_strPath = filename;
		
	XtFree(filename);
    }
	
    pDlg->OnOk();
}

void CFileSelectionDialog::CancelButtonHandler(Widget w, XtPointer client_data, XmAnyCallbackStruct *call_data)
{
    CFileSelectionDialog *pDlg = (CFileSelectionDialog *)client_data;
	
    pDlg->OnCancel();
}

void CFileSelectionDialog::SetCurrentDirectory(const char *strDirectory)
{
    Arg args[20];
    Cardinal argcount = 0;

    ASSERT(strDirectory != NULL);

    XmString string = XmStringCreate((char *)strDirectory, XmFONTLIST_DEFAULT_TAG);

    XtSetArg(args[argcount], XmNresizePolicy, XmRESIZE_NONE); argcount++;

    XtSetValues(FileBox(), args, argcount); 

    XmFileSelectionDoSearch(FileBox(), string); 

    XmStringFree(string);
}
