/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "frame.h"
#include <Xm/Label.h>
#include <Xm/Frame.h>
#include <Xm/Form.h>

CFrame::CFrame(Widget wdgParent)
    : CGuiElement(wdgParent)
{

}

Widget CFrame::Container() const
{
    return m_wdgFrame;
}

Widget CFrame::Frame() const
{
    return m_wdgWorkArea;
}

void CFrame::SetCaption(const char *strCaption)
{
    m_strCaption = strCaption;

    XmString string = XmStringCreate((char *)(const char *)strCaption, XmFONTLIST_DEFAULT_TAG);

    Arg args[20];
    Cardinal argcount = 0;

    XtSetArg(args[argcount], XmNlabelString, string); argcount++;

    XtSetValues(m_wdgTitle, args, argcount);

    XmStringFree(string);
}

const char *CFrame::Caption()
{
    return (const char *)m_strCaption;
}

void CFrame::InternalCreate(unsigned long lStyle)
{
    Arg args[20];
    Cardinal argcount = 0;

    m_wdgFrame = XmCreateFrame(Parent(), "frame", args, argcount);
    XtManageChild(m_wdgFrame);
    
    argcount = 0;
    XtSetArg(args[argcount], XmNframeChildType, XmFRAME_WORKAREA_CHILD); argcount++;
    
    m_wdgWorkArea = XmCreateForm(m_wdgFrame, "frameworkarea", args, argcount);
    XtManageChild(m_wdgWorkArea);

    argcount = 0;
    XtSetArg(args[argcount], XmNframeChildType, XmFRAME_TITLE_CHILD); argcount++;

    m_wdgTitle = XmCreateLabel(m_wdgFrame, "framelabel", args, argcount);
    XtManageChild(m_wdgTitle);
}

