/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#ifndef GRAPHICALOBJECTCONTEXT_H

#define GRAPHICALOBJECTCONTEXT_H

#include "stdlib.h"

class CGraphicalObjectContext
{
 public:
    enum GOC { GRAPHICAL_LIST_ITEM 
    , GRAPHICAL_LIST_BOX 
    , GRIDCELL };
 public:
    CGraphicalObjectContext(void *pObject);

    virtual GOC Type()=NULL;

    inline void *Object() { return m_pObject; }
 private:
    void *m_pObject;
};

#endif
