/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "guimanager.h"
#include <basic/simpleobjectiterator.h>

CGuiManager::CGuiManager(Widget wdgParent, unsigned long lStyle, int nId)
    : CGuiElement(wdgParent, lStyle, nId)
{
}

CGuiManager::CGuiManager(unsigned long lStyle, int nId)
    : CGuiElement(lStyle, nId)
{
}

void CGuiManager::NotifyContextMenu(int nResult)
{

}

void CGuiManager::AddPopupMenu(CSimpleObjectList<CIdString>& List, int nMenuId)
{
    CPopupMenuHandle MenuHandle(this, List, nMenuId);
    
    m_arrMenuHandles += MenuHandle;
}

CPopupMenuHandle *CGuiManager::PopupMenu(int nMenuId)
{
    CSimpleObjectIterator<CPopupMenuHandle> PopupIt;

    PopupIt << &m_arrMenuHandles;

    while (CPopupMenuHandle* pHandle = PopupIt++)
    {
	if (pHandle->MenuId() == nMenuId)
	{
	    return pHandle;
	}
    }

    return NULL;
}

void CGuiManager::OnPopupMenu(int nMenuId, int nId)
{

}

void CGuiManager::OnPopupMenu(int nMenuId, int nId, bool bSet)
{

}

/*void CGuiManager::OnMapPopup(void *pLauncher)
{

}*/

void CGuiManager::OnPreparePopup(Widget wdgLauncher, bool bShift, CPopupMenuHandle *pHandle)
{
    
}

Widget CGuiManager::PopupContainer() const
{
    return Container();
}

// The method RegisterPopupCaller adds a callback to the specified widget, which ensures that the function
// OnPreparePopup works properly even if the popup is launched by this specific widget. This makes sense,
// if the popupmenu is a child of a container widget which itself contains another widget of some size
// that is able to launch the popup menu (which is the case if it does not contain its own popup menu).
// In this case, without the use of RegisterPopupCaller, the popup menu is launched, but the callback of
// the parent of the menu ist NOT called, whenever the event was caught by the child widget of the container
// (i.e. not by the parent of the popup menu). Parents of popup menus do not need to be registered by explicitely
// calling RegisterPopupCaller; this is already being done by the method CPopupMenuHandler::AddPopup.

void CGuiManager::RegisterPopupCaller(Widget wdgCaller, int nMenuId)
{
    CPopupMenuHandle *pHandle = PopupMenu(nMenuId);

    if (pHandle != NULL)
    {
	XtAddCallback(wdgCaller, XmNpopupHandlerCallback, (XtCallbackProc)CPopupMenuHandle::PopupSelection, (XtPointer)pHandle);
    }
    else
    {
	ASSERT(false);
    }
}








