/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "label.h"
#include <Xm/Label.h>
#include <Xm/Xm.h>

CLabel::CLabel()
: CGuiElement()
{

}

CLabel::CLabel(Widget wdgParent)
	: CGuiElement(wdgParent)
{

}

Widget CLabel::Container() const
{
	return m_wdgLabel;
}

const char *CLabel::Caption()
{
	return (const char *)m_strCaption;
}

void CLabel::SetCaption(const char *strCaption)
{
	m_strCaption = strCaption;

	char *strBuffer = new char[strlen(strCaption)+1];
	strcpy(strBuffer,strCaption);
	
	XmString string = XmStringCreate(strBuffer,XmFONTLIST_DEFAULT_TAG);
	delete strBuffer;
		
	Arg args[5];
	Cardinal argcount = 0;
	
	XtSetArg(args[argcount],XmNlabelString,string); argcount++;

	XtSetValues(m_wdgLabel,args,argcount);
		
	XmStringFree(string);
}

void CLabel::InternalCreate(unsigned long lStyle)
{
	XmString string = XmStringCreate("label",XmFONTLIST_DEFAULT_TAG);
	
	Arg args[5];
	Cardinal argcount = 0;
	
	XtSetArg(args[argcount],XmNlabelString,string); argcount++;
	XtSetArg(args[argcount],XmNalignment, XmALIGNMENT_CENTER); argcount++;
	
	m_wdgLabel = XmCreateLabel(Parent(),"label",args,argcount);
	XtManageChild(m_wdgLabel);
		
	XmStringFree(string);
}
