/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "labelledfield.h"
#include <Xm/Form.h>

CLabelledField::CLabelledField(Widget wdgParent)
    : CLabel()
{
    m_wdgParent = wdgParent;
    m_wdgForm = NULL;
}

void CLabelledField::InternalCreate(unsigned long lStyle)
{
    Arg args[20];
    Cardinal argcount = 0;

    CLabel::InternalCreate(lStyle);

    argcount = 0;

    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNtopAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNbottomAttachment, XmATTACH_FORM); argcount++;

    XtSetValues(CLabel::Container(), args, argcount);

    CreateField();

    argcount = 0;

    XtSetArg(args[argcount], XmNleftAttachment, XmATTACH_WIDGET); argcount++;
    XtSetArg(args[argcount], XmNleftWidget, CLabel::Container()); argcount++;
    XtSetArg(args[argcount], XmNtopAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNbottomAttachment, XmATTACH_FORM); argcount++;
    XtSetArg(args[argcount], XmNrightAttachment, XmATTACH_FORM); argcount++;
    
    XtSetValues(Field(), args, argcount);
}

Widget CLabelledField::Container()
{
    return m_wdgForm;
}

void CLabelledField::Create(unsigned long lStyle, Arg *args, Cardinal argcount)
{
    m_wdgForm = XmCreateForm(m_wdgParent, "labelledtopform", args, argcount);
    XtManageChild(m_wdgForm);

    CLabel::Create(m_wdgForm, lStyle);
}





