/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "labelledtextfield.h"
#include "textfield.h"
#include <basic/cstrings.h>

CLabelledTextField::CLabelledTextField(Widget wdgParent)
    : CLabelledField(wdgParent)
{
    m_pField = NULL;
}

void CLabelledTextField::CreateField()
{
    m_pField = new CTextField(LabelParent());
    m_pField->Create();
}

Widget CLabelledTextField::Field()
{
    return m_pField->Container();
}

void CLabelledTextField::InternalDestroy()
{
    if (m_pField != NULL)
    {
	delete m_pField;
    }

    CLabelledField::InternalDestroy();
}

void CLabelledTextField::SetReadOnly(bool bSet)
{
    m_pField->SetReadOnly(bSet);
}

void CLabelledTextField::SetValue(const CStrings &date)
{
    m_pField->SetText(date);
}

CStrings CLabelledTextField::Value() const
{
    return CStrings(m_pField->Text());
}












