/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include <stdio.h>
#include "modaldialog.h"
#include <Xm/DialogS.h>
#include <Xm/BulletinB.h>
#include <Xm/Form.h>

void CModalDialog::InternalCreate(unsigned long lStyle)
{
    Arg args[20];
    Cardinal argcount = 0;
	
    /*XtSetArg(args[argcount],XmNwidth,800); argcount++;
      XtSetArg(args[argcount],XmNheight,600); argcount++;*/
	
    //XtSetArg(args[argcount],XmNkeyboardFocusPolicy,XmPOINTER); argcount++;
    XtSetArg(args[argcount],XmNallowShellResize,True); argcount++;
    XtSetArg(args[argcount], XmNmappedWhenManaged, False); argcount++;
    XtSetArg(args[argcount], XmNdeleteResponse, XmDO_NOTHING); argcount++;

    SetContainer(XmCreateDialogShell(Parent(),"modalshell",args,argcount));

    XtManageChild(Container());
	
    argcount = 0;
    XtSetArg(args[argcount],XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL); argcount++;
		
    m_wdgBulletin = XmCreateBulletinBoard(Container(),"bulletinb",args,argcount);
	
    XtManageChild(m_wdgBulletin);
    
    argcount = 0;

    m_wdgFrame = XmCreateForm(m_wdgBulletin, "topform", args,argcount);
    //m_wdgFrame = XmCreateForm(Container(), "topform", args,argcount);
    XtManageChild(m_wdgFrame);

    CDialog::InternalCreate(lStyle);	

    //XtAddEventHandler(Container(),ResizeRedirectMask,TRUE,(void (*)(_WidgetRec *, void *, _XEvent *, char *))ResizeHandler,(XtPointer)this);
}

void CModalDialog::ResizeHandler(Widget w, XtPointer client_data, XEvent *call_data)
{
    Cardinal argcount = 0;
    Arg args[5];
    
//      XResizeRequestEvent *pEvent = (XResizeRequestEvent *)call_data;

//      XtSetArg(args[argcount], XmNwidth, pEvent->width); argcount++;
//      XtSetArg(args[argcount], XmNheight, pEvent->height); argcount++;
//      XtSetValues(w, args, argcount);

    puts("Resize");
}

void CModalDialog::PostCreate()
{
    Center();
    Arg args[20];
    Cardinal argcount = 0;
    XtSetArg(args[argcount], XmNmappedWhenManaged, True); argcount++;

    XtSetValues(Container(), args, argcount);

    XtMapWidget(Container());
}

CModalDialog::CModalDialog(long lStyle)
    : CDialog(lStyle)
{
    m_bEndDialog = false;
}

Widget CModalDialog::Frame()
{
    return m_wdgFrame;
}

void CModalDialog::SetDimensions(int nX, int nY, int nWidth, int nHeight)
{
    CDialog::SetDimensions(nX,nY,nWidth,nHeight);
	
    Arg args[10]; 
    Cardinal argcount = 0;
	
    if ( nWidth >= 0 )
    {
	XtSetArg(args[argcount],XmNwidth,nWidth>=20 ? nWidth-20 : 0); argcount++;
    }
    if ( nHeight >= 0 )
    {
	XtSetArg(args[argcount],XmNheight,nHeight>=50 ? nHeight-50 : 0); argcount++;
    }

    //XtSetValues(m_wdgBulletin,args,argcount);	
    XtSetValues(Frame(),args,argcount);
}

void CModalDialog::InternalDestroy()
{
    m_bEndDialog = true;
	
    CDialog::InternalDestroy();
}

int CModalDialog::DoModal()
{
    XEvent theEvent;
    XtAppContext app = ApplicationContext();
	
    do
    {
	XtAppNextEvent(app,&theEvent);
	XtDispatchEvent(&theEvent);
    }while(!m_bEndDialog);
	
    //Destroy();
	
    return ReturnValue();
}

void CModalDialog::OnOk()
{
    m_bEndDialog=true;
    
    //SetReturnValue(IDOK);
    CDialog::OnOk();
}

void CModalDialog::OnCancel()
{
    m_bEndDialog=true;
	
    //SetReturnValue(IDCANCEL);
    CDialog::OnCancel();
}

void CModalDialog::OnYes()
{
    m_bEndDialog = true;

    CDialog::OnYes();
}

void CModalDialog::OnNo()
{
    m_bEndDialog = true;

    CDialog::OnNo();
}
