/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#ifndef NUMERICTEXTFIELD_H

#define NUMERICTEXTFIELD_H

#include "textfield.h"

class CNumericTextField : private CTextField
{
 private:
    int m_nValueLength;
    int m_nValueKomma;
 public:
    CNumericTextField(Widget wdgParent);
    void Create(unsigned long lStyle = 0);
    virtual Widget Container();
	
    void SetFormat(int nValueLength, int nValueKomma);
    double Value();
    void SetValue(double dValue);

    inline void SetReadOnly(bool bReadOnly=true) { CTextField::SetReadOnly(bReadOnly); }

    inline int ValueLength() const { return m_nValueLength; }
    inline int ValueKomma() const { return m_nValueKomma; }
    //inline void SendMessage(unsigned long lMask, void *pData=NULL) { CTextField::SendMessage(lMask, pData); }	
    inline operator CMessageClient*() { return (CMessageClient *)this;}
};

#endif
