/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#ifndef SELECTIONLIST_H

#define SELECTIONLIST_H

#include "commonlistbox.h"

class CSelectionList: public CCommonListBox
{
 private:
    Widget m_List;
 private:
    static void HandleSingleSelection(Widget w, XtPointer client_data, XmAnyCallbackStruct *call_data);
 protected:
    virtual Widget InternalList();
    virtual void InternalListCreate(unsigned long lStyle);
    virtual void SelectionChanged();
 public:
    CSelectionList(Widget wdgParent, unsigned long lStyle = 0L, int nId=0);
    virtual Widget Container() const;

    void GetMultipleSelections(CSimpleList<CIdString *> &arrSelections);
};

#endif
