/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "textcontrol.h"

CTextControl::CTextControl()
    : CGuiElement()
{

}

CTextControl::CTextControl(Widget wdgParent)
    : CGuiElement(wdgParent)
{

}

Widget CTextControl::Container() const
{
    return m_wdgTextField;
}

void CTextControl::SetText(const char *strText)
{
    char *strBuffer = new char[strlen(strText)+1];
	
    strcpy(strBuffer,strText);
	
    //XmTextFieldSetString(m_wdgTextField,strBuffer);	
    InternalSetText(strBuffer);
	
    delete strBuffer;
	
    m_strText = strText;
}

const char *CTextControl::Text()
{
    //char *strBuffer = XmTextFieldGetString(m_wdgTextField);
    if (Created())
    {
	char *strBuffer = InternalText();
		
	m_strText = strBuffer;
		
	XtFree(strBuffer);
    }
	
    return (const char *)m_strText;
}

void CTextControl::SetReadOnly(bool bRO)
{
    Arg args[5];
    Cardinal argcount = 0;

    XtSetArg(args[argcount],XmNeditable, !bRO); argcount++;

    XtSetValues(Container(),args,argcount);
}

void CTextControl::InternalDestroy()
{
    m_strText = Text();
	
    CGuiElement::InternalDestroy();
}

CTextControl::~CTextControl()
{

}
