/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "view.h"
#include <Xm/Form.h>
#include "mainframe.h"

CView::CView(Widget wdgParent)
  : CGuiManager(wdgParent)
{
  m_pMainFrame = NULL;
}
		
void CView::SetCaption(const char *strCaption)
{
  m_strCaption = strCaption;
}

const char *CView::Caption()
{
  return (const char *)m_strCaption;
}

/*void CView::InternalCreate(unsigned long lStyle)
{
    CreatePopups();
}	

Widget CView::Container()
{
	return m_wdgForm;
}*/

CView::CView(int nId)
    : CGuiManager(0L, nId)
{
    m_pMainFrame = NULL;
}

Widget CView::Container() const
{
  return NULL;
}

CView::~CView()
{

}

Widget CView::PopupContainer() const
{
    return Parent();
}

void CView::Update()
{
	
}

void CView::UpdateAllViews()
{
  if ( m_pMainFrame != NULL )
    {
      m_pMainFrame->UpdateAllViews(this);
    }
}
