/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "waitcursor.h"

Cursor CWaitCursor::m_Cursor = 0;
int CWaitCursor::m_nActive = 0;

CWaitCursor::CWaitCursor(Widget wdgParent)
    : CGuiElement(wdgParent)
{
    if (m_Cursor == 0)
    {
	m_Cursor = XCreateFontCursor(XtDisplay(wdgParent), XC_watch);
    }
    
    Create();
}

CWaitCursor::~CWaitCursor()
{
    m_nActive--;

    if (m_nActive == 0)
    {
	XUndefineCursor(XtDisplay(Parent()), XtWindow(ApplicationShell(Parent())));    
	Sync();
    }
}

void CWaitCursor::InternalCreate(unsigned long lStyle)
{
    XDefineCursor(XtDisplay(Parent()), XtWindow(ApplicationShell(Parent())), m_Cursor);
    Sync();

    m_nActive++;
}

Widget CWaitCursor::Container() const
{
    return NULL;
}
