/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#include "xapplication.h"

extern Widget xapplication::main_widget;
extern XtAppContext xapplication::app;
#define INITIAL_GEOMETRY 300

const char *xapplication::m_strAppShellName = "Application Shell";

xapplication::xapplication(int w, int h)
{
  	int argc=1;
  	char *name="Application";
  	Arg args[20];
  	Cardinal n=0;

  	if(!main_widget)
  	{
    	// create the application shell
    
    	main_widget = XtAppInitialize(&app, "XM_main", NULL,0,&argc,&name,NULL,args,n);
  	}

  	n = 0;
  	XtSetArg(args[n],XmNwidth,w); n++;
  	XtSetArg(args[n],XmNheight,h); n++;
  	XtSetArg(args[n],XmNkeyboardFocusPolicy,XmEXPLICIT); n++;
  	XtSetArg(args[n],XmNuserData,this); n++;
//    XtSetArg(args[n],XmNallowShellResize,True); n++;

  /*my_shell = XtCreatePopupShell("Application Shell",
				topLevelShellWidgetClass, main_widget,
				args,n); */     
  	my_shell = XtCreatePopupShell(AppShellName(),
				topLevelShellWidgetClass, main_widget,
				args,n);      
  	XtPopup(my_shell, XtGrabNone);
  	
  	m_bEndDialog = false;
}

xapplication::xapplication()
{
  	int argc=1;
  	char *name="Application";
  	Arg args[20];
  	Cardinal n;

  	if(!main_widget)
  	{
    // create the application shell
    
    	main_widget = XtAppInitialize(&app, "XM_main", NULL,0,&argc,&name,NULL,NULL,0);
  	}

  	n = 0;
  	XtSetArg(args[n],XmNwidth,INITIAL_GEOMETRY); n++;
  	XtSetArg(args[n],XmNheight,INITIAL_GEOMETRY); n++;
  	XtSetArg(args[n],XmNkeyboardFocusPolicy,XmEXPLICIT); n++;
  	XtSetArg(args[n],XmNuserData,this); n++;
//    XtSetArg(args[n],XmNallowShellResize,True); n++;
	XtSetArg(args[n], XmNdeleteResponse, XmDO_NOTHING); n++;

  /*my_shell = XtCreatePopupShell("Application Shell",
				topLevelShellWidgetClass, main_widget,
				args,n); */     
  	my_shell = XtCreatePopupShell(AppShellName(),
				topLevelShellWidgetClass, main_widget,
				args,n);      
  	XtPopup(my_shell, XtGrabNone);

  	depth = DefaultDepth(XtDisplay(my_shell),DefaultScreen(XtDisplay(my_shell)));
  	
  	m_bEndDialog = false;
}

xapplication::~xapplication()
{
    //XtUnmapWidget(my_shell);
    //XtDestroyWidget(my_shell);
}

int xapplication::get_width()
{
  int val;
  
  Arg args[5];
  
  XtSetArg(args[0],XmNwidth,&val);
  XtGetValues(my_shell,args,1);
  return val;
}

int xapplication::get_height()
{
  int val;
  
  Arg args[5];
  
  XtSetArg(args[0],XmNheight,&val);
  XtGetValues(my_shell,args,1);
  return val;
}

void xapplication::set_name(char *wname)
{
  Arg args[10];
  Cardinal n;

  n = 0;
  XtSetArg(args[n],XmNtitle,wname); n++;

  XtSetValues(my_shell,args,n);
}

void xapplication::wait_for_event(void)
{
    XEvent theEvent;
    XtAppContext app = get_application_context();
	
    do
    {
	XtAppNextEvent(app,&theEvent);
	XtDispatchEvent(&theEvent);
    }while(!m_bEndDialog);
}  

void xapplication::EndAppLoop()
{
	m_bEndDialog = true;
}

XtAppContext xapplication::get_application_context() 
{ 
    return app;
}

Widget xapplication::get_main_widget() 
{ 
    return main_widget;
}





