/*******************************************************************************
 *
 * libgui Version 0.0.1
 *
 * libgui is a simple framework of GUI classes for X11/Motif widgets written in C++.
 *
 * The full text of the GNU General Public License can be found in the doc 
 * directory.
 *
 * Copyright (C) 2002, 2003 Stefan Hoefer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * You can contact Stefan Hoefer via email at stefan@hoefer.ch
 *
 ******************************************************************************/

#ifndef XAPPLICATION_H
#define XAPPLICATION_H

#include <X11/IntrinsicP.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/MainW.h>
#include <Xm/PushB.h>
#include <Xm/CascadeB.h>
#include <Xm/DrawingA.h>
#include <unistd.h>
/*#include <iostream.h>*/

//#include "container.h"
#include "definitions.h"

class xapplication
{
 private:
    static Widget main_widget;
    static XtAppContext app;
    int depth;
    static const char *m_strAppShellName;
    bool m_bEndDialog;	
 protected:
    Widget my_shell;
 public:
    static const char *AppShellName()	{ return m_strAppShellName; }
   
    inline int get_depth() { return depth;}
    xapplication();
    xapplication(int,int);
    static XtAppContext get_application_context();
    static Widget get_main_widget();
    inline Widget get_shell() { return my_shell;}
    ~xapplication();
    inline XtAppContext get_app_context(){return app;}
    virtual void popup() {XtPopup(my_shell,XtGrabNone);}
    virtual void popdown() {XtPopdown(my_shell);}
    int get_width();
    int get_height();
    void set_name(char *);
    void wait_for_event(void);
 protected:
    void EndAppLoop();
};

#endif








